<?php
# کرون یک دقیقه
# برای ارسال بنر ها به کانال ها
//======================= [ files ]===========================
include_once('../config.php');
include_once('../class/Database.php');
include_once('../class/Logger.php');
include_once('../class/Telegram.php');
//======================= [ main ]===========================
$DB = new Database('localhost',$DBNAME,$DBUSERNAME,$DBPASS);

$getchannels = $DB->select('channel');

if (empty($getchannels) == true ){
    echo 'There is no channel';
    die;
}

$time = time();

if (is_array($getchannels) && isset($getchannels[1]['id'])) $list_channel = $getchannels ;
else {
    $list_channel = [];
    $list_channel[] = $getchannels ;
}

$telegram = new Telegram($API_KEY,false);


foreach ($list_channel as $channel) {

    # برسی اینکه محدودیت زمان رو رد کرده یا نه
    $get_order_channel = $DB->select('banner_send',"channel_id={$channel['id']}","send_time","1","send_time DESC");
    
    if (empty($get_order_channel) == true || empty($get_order_channel) == false && $get_order_channel['send_time'] < ($time - $channel['gap_send_next_banner'] * 60 + 10 ) ) {

        # دریافت آگهی های ثبت شده برای کانال
        $DB->query("SET @row_number = 0;");
        $get_channel_bannerr = $DB->queryselect("SELECT (@row_number := @row_number + 1) AS new_id,`id`,`banner_id`,`channel_id`,`count_send`,`order_time` FROM banner_order WHERE `channel_id`={$channel['id']} ORDER BY id;");
       
        # برسی اینکه اصلا بنر داره کانال یا نه
        if (empty($get_channel_bannerr) == false){

            if (is_array($get_channel_bannerr) && isset($get_channel_bannerr[1]['id'])) $get_channel_banner = $get_channel_bannerr ;
            else {
                $get_channel_banner = [];
                $get_channel_banner[] = $get_channel_bannerr ;
            }

            if (count($get_channel_banner) > $channel['previous_index_send']){

                $index_send = $channel['previous_index_send'] ;
                $next_index_send = $channel['previous_index_send'] + 1 ; 
                $DB->update('channel',['previous_index_send' => $next_index_send],"id={$channel['id']}");
            }else{

                $index_send = 0 ;
                $DB->update('channel',['previous_index_send' => 1],"id={$channel['id']}");
            }
            
            $get_banner = $DB->select('banner',"id={$get_channel_banner[$index_send]['banner_id']}");
            if (empty($get_banner) == false){

                if($get_banner['type_file'] == 'forward') $send = $telegram->forwardMessage(['chat_id' => $channel['chatid'] ,'from_chat_id' => $get_banner['from_id'],'message_id' => $get_banner['file_id'] ]);
                elseif ($get_banner['type_file'] == 'message') $send = $telegram->sendMessage(['chat_id' => $channel['chatid'] ,'text' => $get_banner['description']]);
                else $send = $telegram->sendFile($get_banner['type_file'],['chat_id' => $channel['chatid'] ,$get_banner['type_file'] => $get_banner['file_id'],'caption' => $get_banner['description']]) ;
                
                if (isset($send['ok']) && $send['ok'] == true) {

                    # آپدیت امار
                    $count_send = $get_channel_banner[$index_send]['count_send'] + 1 ;
                    $DB->update('banner_order',['count_send' => $count_send ],"id={$get_channel_banner[$index_send]['id']}");
                    
                    $msg = $send['result']['message_id'];
                    $DB->insert('banner_send',['banner_id' => $get_banner['id'] ,'channel_id' => $channel['id'] ,'msg_send_channel' => $msg ,'send_time' => $time]);

                    # حذف آگهی های قبلی
                    $DB->query("SET @row_number = 0;");
                    $get_channel_sendd = $DB->queryselect("SELECT (@row_number := @row_number + 1) AS new_id,`id`,`msg_send_channel` FROM banner_send WHERE `channel_id`={$channel['id']} ORDER BY id;");
                    if (is_array($get_channel_sendd) && isset($get_channel_sendd[1]['id'])) $get_channel_send = $get_channel_sendd ;
                    else {
                        $get_channel_send = [];
                        $get_channel_send[] = $get_channel_sendd ;
                    }

                    if ($channel['max_save_banner'] < count($get_channel_send)) {
                        
                        $count_bagi_mande = count($get_channel_send) - $channel['max_save_banner'];
                        for ($i=0; $i < $count_bagi_mande; $i++) { 
                            $telegram->deleteMessage(['chat_id' => $channel['chatid'] ,'message_id' => $get_channel_send[$i]['msg_send_channel'] ]);
                            $DB->delete('banner_send',"id={$get_channel_send[$i]['id']}");
                        }
                        
                    }

                }
            }
        };
    }
}

echo 'ok';
//         # 8.1
//         $ddd = "
// SELECT 
//     ROW_NUMBER() OVER (ORDER BY id) AS new_id, 
//     `id`,`chatid`,`invite_link`,`gap_send_next_banner`,`max_save_banner`,`add_time` 
// FROM 
//     channel;
//         ";
?>